//basicline.cpp

#include <windows.h>
#include <math.h>
#include "ezjig.h"
#include "create.h"
#include "mybit.h"
#include "ini.h"

CREATE CA;

struct	Point_str {
	double	x;
	double	y;
};
typedef Point_str Point;

Point	hline_const[17][LINE_INITIAL_MAX_2];//PVSij~Sitj~Wij{Pij
Point	vline_const[17][LINE_INITIAL_MAX_2];//PVSij~Sitj~Wij{Pij

void line_const_init()
{
	int		i, j;

	for (i=0; i<4; i++) {			//hline_const[0]`[3]
		hline_const[i][0].x = 0;
		hline_const[i][0].y = 0;
		vline_const[i][0].x = 0;
		vline_const[i][0].y = 0;
		for (j=1; j<mx-1; j++) {
			hline_const[i][j].x = (double)ini.line_initial[i][j].x / (double)216;
			hline_const[i][j].y = (double)ini.line_initial[i][j].y / (double)216;
			vline_const[i][j].x = hline_const[i][j].y;
			vline_const[i][j].y = hline_const[i][j].x;
		}
		hline_const[i][mx-1].x = 1;
		hline_const[i][mx-1].y = 0;
		vline_const[i][mx-1].x = 0;
		vline_const[i][mx-1].y = 1;
	}
	/*Et܂͏㉺t쐬*/		//hline_const[4]`[7]
	for (i=4; i<8; i++) {
		for (j=0; j<mx; j++) {
			hline_const[i][j].x = (double)1.0 - hline_const[i-4][mx-1-j].x;
			hline_const[i][j].y =               hline_const[i-4][mx-1-j].y;
			vline_const[i][j].x =               vline_const[i-4][mx-1-j].x;
			vline_const[i][j].y = (double)1.0 - vline_const[i-4][mx-1-j].y;
		}
	}
	/*Ԃ쐬*/			//hline_const[8]`[15]
	for (i=8; i<16; i++) {
		for (j=0; j<mx; j++) {
			hline_const[i][j].x =   hline_const[i-8][j].x;
			hline_const[i][j].y = - hline_const[i-8][j].y;
			vline_const[i][j].x = - vline_const[i-8][j].x;
			vline_const[i][j].y =   vline_const[i-8][j].y;
		}
	}
	/*쐬*/				//hline_const[16]
	for (j=0; j<mx; j++) {
		hline_const[16][j].x = 0;
		hline_const[16][j].y = 0;
		vline_const[16][j].x = 0;
		vline_const[16][j].y = 0;
	}
	hline_const[16][mx-1].x = 1;
	vline_const[16][mx-1].y = 1;
}

void bzline_calc_pnum(int &pi_num, int &img_w, int &img_h, int &pw, int &ph, int &w_num, int &h_num, BOOL seiretu)
{
	double		sz;
	int			wh;

	if (seiretu==TRUE) {
		//ŏ犮Ԃɂ郂[hŔwi摜쐬Ɏg[h
		//F7L[ł̃[hɂȂ
		//؂Ȃꍇ͒ʏ̃Q[̕@ŕ̂ŉ摜̏㉺E؂
		int			max_wh, sv_wh=0, sv_num=0, num;
		if (img_w>img_h)
			max_wh	= img_w;
		else
			max_wh	= img_h;
		for (wh=10; wh<=max_wh; wh+=2) {
			if ((img_w%wh)==0 && (img_h%wh)==0) {//؂邩ǂ
				num		= (img_w / wh) * (img_h / wh);
				if (num>pi_num) {
					sv_wh	= wh;
					sv_num	= num;
				}
				else {
					if ((num-pi_num)<(pi_num-sv_num)) {
						sv_wh	= wh;
					}
					break;
				}
			}
		}
		if (sv_wh==0)
			MessageBox(NULL, "؂镪܂B\n[o镪ɂȂ܂B", "ezjig", MB_OK);
		else {
			pw		= sv_wh;
			ph		= sv_wh;
			w_num	= img_w / pw;
			h_num	= img_h / ph;
			return;
		}
	}

	//pi_numɋ߂߂iʏ̃Q[Jñs[X̑傫ĚvZj
	sz		= (double)img_w * (double)img_h / (double)pi_num;	//Ŝ̖ʐςs[XŊāAPs[X̖ʐς߂
	wh		= (int)sqrt( sz );									//Ps[X͐`ƂĂPӂ̒߂
	if (wh%2==1)
		wh--;//ɂ
	pw		= wh;
	ph		= wh;
	w_num	= img_w / pw;
	h_num	= img_h / ph;
}

BZ* bzline_init(int &pi_num, int &img_w, int &img_h, BOOL seiretu, RECT &seiretu_rect0, RECT &seiretu_rect1)
{
	int			wh, pw, ph, w_num, h_num;
	int			i, x, y, k;
	int			n, bz_num, n_x0, *n_y0;
	BZ			*bzt;

	//]̃s[Xɋ߂vZiimg_w,img_h͌̂Q{ɂĂj
	bzline_calc_pnum(pi_num, img_w, img_h, pw, ph, w_num, h_num, seiretu);

	//Aimg̐؂TCYԂ
	pi_num	= w_num * h_num;
	img_w	= pw * w_num;
	img_h	= ph * h_num;

	//xWGȐ̏
	line_const_init();

	bz_num				= w_num * (h_num-1) + h_num * (w_num-1);
	bzt					= new BZ[bz_num+1];
	bzt[bz_num].num		= 0;
	bzt[bz_num].bz		= NULL;
	i					= 0;
	n_y0				= new int[w_num];

	//xWGȐ_ɔzu
	srand(GetTickCount());
	for (y=0; y<h_num; y++) {
		for (x=0; x<w_num; x++) {
			if (x<w_num-1) {
				//c
				bzt[i].num	= LINE_INITIAL_MAX_2;
				bzt[i].bz	= (POINT*)GlobalAlloc(GMEM_FIXED, LINE_INITIAL_MAX_2*sizeof(POINT));
				n			= rand() % 16;
				if (seiretu==TRUE) {
					if (x==0)
						n_x0	= n;
					else
					if (x==w_num-2)
						n		= n_x0;
				}
				for (k=0; k<mx; k++) {
					bzt[i].bz[k].x = (long)( (double)pw * ( vline_const[n][k].x + (double)(x+1) ) );
					bzt[i].bz[k].y = (long)( (double)ph * ( vline_const[n][k].y + (double) y    ) );
				}
				i++;
			}
			if (y<h_num-1) {
				//
				bzt[i].num	= LINE_INITIAL_MAX_2;
				bzt[i].bz	= (POINT*)GlobalAlloc(GMEM_FIXED, LINE_INITIAL_MAX_2*sizeof(POINT));
				n			= rand() % 16;
				if (seiretu==TRUE) {
					if (y==0)
						n_y0[x]	= n;
					else
					if (y==h_num-2)
						n		= n_y0[x];
				}
				for (k=0; k<mx; k++) {
					bzt[i].bz[k].x = (long)( (double)pw * ( hline_const[n][k].x + (double) x    ) );
					bzt[i].bz[k].y = (long)( (double)ph * ( hline_const[n][k].y + (double)(y+1) ) );
				}
				i++;
			}
		}
	}
	if (seiretu==TRUE) {
		seiretu_rect0.left		= 0;
		seiretu_rect0.top		= 0;
		seiretu_rect0.right		= pw * w_num;
		seiretu_rect0.bottom	= ph * h_num;
		seiretu_rect0.left		/= 2;
		seiretu_rect0.top		/= 2;
		seiretu_rect0.right		/= 2;
		seiretu_rect0.bottom	/= 2;
		seiretu_rect1.left		= pw;
		seiretu_rect1.top		= ph;
		seiretu_rect1.right		= pw * (w_num-1);
		seiretu_rect1.bottom	= ph * (h_num-1);
		seiretu_rect1.left		/= 2;
		seiretu_rect1.top		/= 2;
		seiretu_rect1.right		/= 2;
		seiretu_rect1.bottom	/= 2;
	}
	delete n_y0;
	return(bzt);
}

LRESULT CALLBACK basicline_Win_Func(HWND, UINT, WPARAM, LPARAM);

void basicline_register_class(HINSTANCE hInstance)
{
	WNDCLASSEX wcl;

	/* EBhENX` */
	wcl.cbSize			= sizeof(WNDCLASSEX);
	wcl.hInstance		= hInstance;								/* ̃CX^Xւ̃nh */
	wcl.lpszClassName	= "BasicLineWin";							/* EBhENX̖O */
	wcl.lpfnWndProc		= basicline_Win_Func;						/* EBhE֐ */
	wcl.style			= 0;										/* ftHg̃X^C */
	wcl.hIcon			= LoadIcon(hInstance, "EZJIG_ICON");//NULL;	/* ACR */
	wcl.hIconSm			= NULL; //LoadIcon(NULL, IDI_WINLOGO);		/* ACR */
	wcl.hCursor			= LoadCursor(NULL, IDC_ARROW);				/* J[\̃X^C */
	wcl.lpszMenuName	= NULL;										/* j[gpȂ */
	wcl.cbClsExtra		= 0;										/* ̂ق͕̏KvȂ */
	wcl.cbWndExtra		= 0;										/* ̂ق͕̏KvȂ */
	wcl.hbrBackground	= NULL;//(HBRUSH) GetStockObject(WHITE_BRUSH);		/* wi͔ */

	/* EBhENXo^ */
	if(!RegisterClassEx(&wcl)) return;
}

LRESULT CALLBACK LineDlgProc(HWND hDlgWnd, UINT msg, WPARAM wp, LPARAM lp);
HWND	Line_hDlgWnd;
HWND	Line_hWnd;

HWND basicline_create_window(HINSTANCE hInstance, HWND owner_hwnd)
{
	POINT			p;
	RECT			r;
	int				w, h;
	static BOOL		first=TRUE;

	if (first==TRUE) {
		first	= FALSE;
		basicline_register_class(hInstance);
	}
	p.x			= 0;
	p.y			= 0;
	ClientToScreen(owner_hwnd, &p);
	r.left		= 0;
	r.top		= 0;
	r.right		= 436;
	r.bottom	= 436;
	AdjustWindowRect(&r, WS_CHILD | WS_CLIPSIBLINGS | WS_OVERLAPPEDWINDOW, FALSE);
	w			= r.right  - r.left;
	h			= r.bottom - r.top;
	Line_hWnd = CreateWindow(
		"BasicLineWin",						/* EBhENX */
		"s[X`",						/* ^Cg */
		WS_POPUP | WS_CAPTION | WS_SYSMENU,
		p.x,//CW_USEDEFAULT,				/* XW 	- WindowsɌ߂ */
		p.y,//CW_USEDEFAULT,				/* YW	- WindowsɌ߂ */
		w,//CW_USEDEFAULT,					/*  		- WindowsɌ߂ */
		h,//CW_USEDEFAULT,					/* 		- WindowsɌ߂ */
		owner_hwnd,							/* eEBhE */
		NULL,								/* j[gpȂ */
		hInstance,							/* vỖCX^X̃nh */
		NULL								/* ̂ق͕̈KvȂ */
	);

	Line_hDlgWnd = CreateDialog(hInstance, "LINEDLG", owner_hwnd, (DLGPROC)LineDlgProc);
	if (Line_hDlgWnd == NULL)
		return FALSE;

	/* EBhE\ */
	ShowWindow(Line_hWnd, SW_SHOW);
	ShowWindow(Line_hDlgWnd, SW_SHOW);
	UpdateWindow(Line_hWnd);
	UpdateWindow(Line_hDlgWnd);
	return(Line_hWnd);
}

void sample(HDC dc, POINT line_initial_temp[])
{
	MYBIT		img, msk, pimg, bimg;
	BZ			bz[5];
	int			i;
	COLORREF	*c, *c1, *c2, *c3, *c4;

	img .Clear(RGB(128,128,128), 110, 110);
	pimg.Clear(RGB(128,128,128), 110, 110);
	bimg.Clear(RGB(200,200,200), 110, 110);
	msk .Clear(RGB(255,255,255), 220, 220);
	bz[0].Alloc(10);
	bz[1].Alloc(10);
	bz[2].Alloc(10);
	bz[3].Alloc(10);
	for (i=0; i<mx; i++) {
		//
		bz[0].bz[i].x	=   line_initial_temp[i].x / 2 + 55;
		bz[0].bz[i].y	=   line_initial_temp[i].y / 2 + 55;
		//
		bz[1].bz[i].x	=   line_initial_temp[i].y / 2 + 55;
		bz[1].bz[i].y	=   line_initial_temp[i].x / 2 + 55;
		//E
		bz[2].bz[i].x	= - line_initial_temp[i].y / 2 + 55 + 108;
		bz[2].bz[i].y	=   line_initial_temp[i].x / 2 + 55;
		//
		bz[3].bz[i].x	=   line_initial_temp[i].x / 2 + 55;
		bz[3].bz[i].y	= - line_initial_temp[i].y / 2 + 55 + 108;
	}
	msk.BZline(bz, RGB(0,0,0));
	c	= msk.GetC();
	c1	= c + (219- 55     )*220 + 55;
	c2	= c + (219- 55     )*220 + 55 + 108;
	c3	= c + (219-(55+108))*220 + 55;
	c4	= c + (219-(55+108))*220 + 55 + 108;
	*c1	= RGB(0,0,0);
	*c2	= RGB(0,0,0);
	*c3	= RGB(0,0,0);
	*c4	= RGB(0,0,0);
	CA.Sample(&img, &msk, &pimg);
	bimg.PasteA(&pimg,0,0);
	bimg.Display(0,0,dc);
}

LRESULT CALLBACK basicline_Win_Func(HWND This_hwnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	static HDC			dc;
	static HBITMAP		bit,	bit_old;
	static int			sel=-1;
	static int			lno;
	static int			desk_x, desk_y;
	static int			x0=110, y0=110;
	static HPEN			pen1, pen2, pen3, pen_old;
	static POINT		line_initial_temp[LINE_INITIAL_MAX_1][LINE_INITIAL_MAX_2];
	static int			sv_thick, sv_light;
	static BOOL			ok_button;

	POINT		mouse, p0[10], p1[10], p2[10], p3[10];
	COLORREF	rgb;
	int			i, j, dx, dy;
	PAINTSTRUCT	p_str;
	HDC			wdc;
	POINT		ln[5];

//	HINSTANCE hInst = (HINSTANCE)GetWindowLong(This_hwnd, GWL_HINSTANCE);

	switch(message) {
	case WM_CREATE:
		wdc			= GetDC(This_hwnd);									/*foCXReLXgnh擾*/
		desk_x		= GetSystemMetrics(SM_CXSCREEN);					/*fXNgbv̕*/
		desk_y		= GetSystemMetrics(SM_CYSCREEN);					/*fXNgbv̍*/
		dc			= CreateCompatibleDC(wdc);							/*݊foCXReLXg擾*/
		bit			= CreateCompatibleBitmap(wdc, desk_x, desk_y);		/*݊rbg}bv擾(fXNgbvŜ̑傫)*/
		ReleaseDC(This_hwnd, wdc);										/*foCXReLXgJ*/
		pen1		= (HPEN)CreatePen(PS_SOLID, 1, RGB(0,0,0));
		pen2		= (HPEN)CreatePen(PS_SOLID, 1, RGB(150,150,255));
		pen3		= (HPEN)CreatePen(PS_SOLID, 1, RGB(150,255,150));
		bit_old		= (HBITMAP)SelectObject(dc,  bit);					/*rbg}bvI*/
		pen_old		= (HPEN)SelectObject(dc, pen1);

		lno = 0;
		for (i=0; i<LINE_INITIAL_MAX_1; i++) {
			for (j=0; j<LINE_INITIAL_MAX_2; j++) {
				line_initial_temp[i][j]	= ini.line_initial[i][j];
			}
		}
		sv_thick	= ini.edge_thick;
		sv_light	= ini.edge_light;
		ok_button	= FALSE;
		InvalidateRect(This_hwnd, NULL, 1);
		break;
	case WM_LBUTTONDOWN:
		mouse.x = LOWORD(lParam);
		mouse.y = HIWORD(lParam);
		for (i=1; i<9; i++) {	/*n_AI_͑IsƂ*/
			dx = ( mouse.x - x0 ) - line_initial_temp[lno][i].x;
			dy = ( mouse.y - y0 ) - line_initial_temp[lno][i].y;
			if ( dx < 5 && dx > -5 && dy < 5 && dy > -5 ) {
				sel = i;
				break;
			}
		}
		break;
	case WM_LBUTTONUP:
		sel = -1;
		break;
	case WM_MOUSEMOVE:
		if (sel>=0) {
			mouse.x = LOWORD(lParam);
			mouse.y = HIWORD(lParam);
			line_initial_temp[lno][sel].x = mouse.x - x0;
			line_initial_temp[lno][sel].y = mouse.y - y0;
			InvalidateRect(This_hwnd, NULL, 0);
		}
		break;
	case WM_PAINT:
		PatBlt(dc, 0, 0, desk_x, desk_y, WHITENESS);
		ln[0].x = x0;       ln[0].y = y0;
		ln[1].x = x0 + 108; ln[1].y = y0 - 108;
		ln[2].x = x0 + 216; ln[2].y = y0;
		ln[3].x = x0 + 108; ln[3].y = y0 + 108;
		ln[4].x = x0;       ln[4].y = y0;
		SelectObject(dc, pen2);
		Polyline(dc, ln, 5);
		for (i=-108; i<=108; i+=12) {
			if (i==0)
				SelectObject(dc, pen3);
			else
				SelectObject(dc, pen2);
			ln[0].x = x0;       ln[0].y = y0 + i;
			ln[1].x = x0 + 216; ln[1].y = y0 + i;
			Polyline(dc, ln, 2);
			ln[0].y = y0 - 108; ln[0].x = x0 + i + 108;
			ln[1].y = y0 + 108; ln[1].x = x0 + i + 108;
			Polyline(dc, ln, 2);
		}
		for (i=0; i<10; i++) {
			if (i==0 || i==3 || i==6 || i==9)
				rgb = RGB(0,0,0);
			else
				rgb = RGB(255,0,0);
			SetPixel(dc, line_initial_temp[lno][i].x-1+x0, line_initial_temp[lno][i].y-1+y0, rgb);
			SetPixel(dc, line_initial_temp[lno][i].x-1+x0, line_initial_temp[lno][i].y+0+y0, rgb);
			SetPixel(dc, line_initial_temp[lno][i].x-1+x0, line_initial_temp[lno][i].y+1+y0, rgb);
			SetPixel(dc, line_initial_temp[lno][i].x+0+x0, line_initial_temp[lno][i].y-1+y0, rgb);
			SetPixel(dc, line_initial_temp[lno][i].x+0+x0, line_initial_temp[lno][i].y+0+y0, rgb);
			SetPixel(dc, line_initial_temp[lno][i].x+0+x0, line_initial_temp[lno][i].y+1+y0, rgb);
			SetPixel(dc, line_initial_temp[lno][i].x+1+x0, line_initial_temp[lno][i].y-1+y0, rgb);
			SetPixel(dc, line_initial_temp[lno][i].x+1+x0, line_initial_temp[lno][i].y+0+y0, rgb);
			SetPixel(dc, line_initial_temp[lno][i].x+1+x0, line_initial_temp[lno][i].y+1+y0, rgb);
		}
		for (i=0; i<10; i++) {
			p0[i].x =   line_initial_temp[lno][i].x + x0;
			p0[i].y =   line_initial_temp[lno][i].y + y0;
			p1[i].x =   p0[i].x;
			p1[i].y = - p0[i].y + 216 + y0 + y0;
			p2[i].x =   p0[i].y;
			p2[i].y =   p0[i].x;
			p3[i].x = - p0[i].y + 216 + x0 + x0;
			p3[i].y =   p0[i].x;
		}
		SelectObject(dc, pen1);
		PolyBezier(dc, p0, 10);
		PolyBezier(dc, p1, 10);
		PolyBezier(dc, p2, 10);
		PolyBezier(dc, p3, 10);
		sample(dc, line_initial_temp[lno]);

		/*zfoCXɃobNAbvĂC[Wĕ`悷*/
		wdc = BeginPaint(This_hwnd, &p_str);						/*HDCƍĕ`͈͂擾*/
		BitBlt(wdc,
			   p_str.rcPaint.left,							/*wdĉ̈ʒu(x)*/
			   p_str.rcPaint.top,							/*wdĉ̈ʒu(y)*/
			   p_str.rcPaint.right  - p_str.rcPaint.left,	/*wdĉ̕*/
			   p_str.rcPaint.bottom - p_str.rcPaint.top,	/*wdĉ̍*/
			   dc,
			   p_str.rcPaint.left,							/*memdc1̂(x)*/
			   p_str.rcPaint.top,							/*memdc1̂(y)*/
			   SRCCOPY);									/*PRs[*/
		EndPaint(This_hwnd, &p_str);								/*HDCJ*/

		break;
	case IDC_RADIO1:
	case IDC_RADIO2:
	case IDC_RADIO3:
	case IDC_RADIO4:
		lno		= message - IDC_RADIO1;
		InvalidateRect(This_hwnd, NULL, 0);
		break;
	case IDC_EDGE_T_LO:
		ini.edge_thick--;
		if (ini.edge_thick<0)
			ini.edge_thick = 0;
		InvalidateRect(This_hwnd, NULL, 0);
		break;
	case IDC_EDGE_T_HI:
		ini.edge_thick++;
		InvalidateRect(This_hwnd, NULL, 0);
		break;
	case IDC_EDGE_U_LO:
		ini.edge_light--;
		if (ini.edge_light<0)
			ini.edge_light = 0;
		InvalidateRect(This_hwnd, NULL, 0);
		break;
	case IDC_EDGE_U_HI:
		ini.edge_light++;
		InvalidateRect(This_hwnd, NULL, 0);
		break;
	case IDC_OK:
		for (i=0; i<LINE_INITIAL_MAX_1; i++) {
			for (j=0; j<LINE_INITIAL_MAX_2; j++) {
				ini.line_initial[i][j]	= line_initial_temp[i][j];
			}
		}
		ok_button	= TRUE;
		PostMessage(This_hwnd, WM_CLOSE,0, 0);
		break;
	case IDC_CANCEL:
		PostMessage(This_hwnd, WM_CLOSE,0, 0);
		break;
	case WM_CLOSE:
		if (ok_button==FALSE) {
			ini.edge_thick = sv_thick;
			ini.edge_light = sv_light;
		}
		SelectObject(dc,  pen_old);
		SelectObject(dc,  bit_old);
		DeleteObject(bit);
		DeleteDC(dc);
		DestroyWindow(This_hwnd);
		DestroyWindow(Line_hDlgWnd);
		break;
	default:
		return DefWindowProc(This_hwnd, message, wParam, lParam);/* Windows 98ŏ */
	}
	return 0;
}

LRESULT CALLBACK LineDlgProc(HWND hDlgWnd, UINT msg, WPARAM wp, LPARAM lp)
{
	if (lp==NULL) ;//gpȂ̃[jO߂̖ʂȃR[fBO

	RECT		r1, r2;
	int			dx;

	switch (msg) {
	case WM_INITDIALOG:
		SendMessage(GetDlgItem(hDlgWnd, IDC_RADIO1), BM_SETCHECK, (WPARAM)1, 0L);
		SendMessage(GetDlgItem(hDlgWnd, IDC_RADIO2), BM_SETCHECK, (WPARAM)0, 0L);
		SendMessage(GetDlgItem(hDlgWnd, IDC_RADIO3), BM_SETCHECK, (WPARAM)0, 0L);
		SendMessage(GetDlgItem(hDlgWnd, IDC_RADIO4), BM_SETCHECK, (WPARAM)0, 0L);
		GetWindowRect(hDlgWnd, &r1);
		GetWindowRect(Line_hWnd, &r2);
		dx			= r2.right - r1.left;
		r1.left		= r1.left  + dx;
		r1.right	= r1.right + dx;
		MoveWindow(hDlgWnd, r1.left, r1.top, r1.right-r1.left, r1.bottom-r1.top, TRUE);
		break;
	case WM_COMMAND:
		switch (LOWORD(wp)) {
		case IDC_RADIO1:
		case IDC_RADIO2:
		case IDC_RADIO3:
		case IDC_RADIO4:
		case IDC_EDGE_T_LO:
		case IDC_EDGE_T_HI:
		case IDC_EDGE_U_LO:
		case IDC_EDGE_U_HI:
			PostMessage(Line_hWnd, LOWORD(wp),0, 0);
			break;
		case IDOK:
			PostMessage(Line_hWnd, IDC_OK,0, 0);
			break;
		case IDCANCEL:
			PostMessage(Line_hWnd, IDC_CANCEL,0, 0);
			break;
		default:
			return(FALSE);
		}
		break;
	default:
		return(FALSE);
	}
	return(TRUE);
}


