#include <windows.h>
#include "mybit.h"

HWND	owner_hwnd;
HWND	guide_hwnd=NULL;
MYBIT	guide_img;	//
MYBIT	guide_disp;	//TCY

LRESULT CALLBACK Guide_win_Func(HWND, UINT, WPARAM, LPARAM);
void guide_register_class(HINSTANCE hInst);
HWND guide_create_window(HWND owner, MYBIT *img);

HWND guide_init(HINSTANCE hInst, HWND owner, MYBIT *img)
{
	static	BOOL	first=TRUE;

	if (first==TRUE) {
		first	= FALSE;
		guide_register_class(hInst);
	}
	if (guide_hwnd==NULL)
		guide_hwnd	= guide_create_window(owner, img);
	return(guide_hwnd);
}

void guide_term()
{
	if (guide_hwnd!=NULL)
		SendMessage(guide_hwnd, WM_CLOSE, 0, 0);
	guide_hwnd	= NULL;
}

void guide_register_class(HINSTANCE hInst)
{
	WNDCLASSEX	wcl;

	/* EBhENX` */
	wcl.cbSize			= sizeof(WNDCLASSEX);
	wcl.hInstance		= hInst;			/* ̃CX^Xւ̃nh */
	wcl.lpszClassName	= "GuideWin";		/* EBhENX̖O */
	wcl.lpfnWndProc		= Guide_win_Func;	/* EBhE֐ */
	wcl.style			= 0;				/* ftHg̃X^C */
	wcl.hIcon			= LoadIcon(hInst, "EZJIG_ICON");	/* ACR */
	wcl.hIconSm			= NULL;				/* ACR */
	wcl.hCursor			= LoadCursor(NULL, IDC_ARROW);	/* J[\̃X^C */
	wcl.lpszMenuName	= NULL;				/* Cj[ */
	wcl.cbClsExtra		= 0;				/* ̂ق͕̏KvȂ */
	wcl.cbWndExtra		= 0;				/* ̂ق͕̏KvȂ */
	wcl.hbrBackground	= NULL;//(HBRUSH) GetStockObject(WHITE_BRUSH);	/* wi͔ */
	/* EBhENXo^ */
	if(!RegisterClassEx(&wcl)) return;
}

HWND guide_create_window(HWND owner, MYBIT *img)
{
	HINSTANCE	hInst;
	HWND		hwnd;
	RECT		r;

	guide_img.Copy(img);
	hInst		= (HINSTANCE)GetWindowLong(owner, GWL_HINSTANCE);
	owner_hwnd	= owner;
	hwnd = CreateWindow(
			"GuideWin",		/* EBhENX */
			"KCh",		/* ^Cg */
//			WS_OVERLAPPEDWINDOW,	/* EBhEX^C - W */
			WS_OVERLAPPED | WS_CAPTION | WS_THICKFRAME | WS_SYSMENU,
			0,				//CW_USEDEFAULT,		/* XW 	- WindowsɌ߂ */
			0,				//CW_USEDEFAULT,		/* YW	- WindowsɌ߂ */
			100,			//CW_USEDEFAULT,		/*  		- WindowsɌ߂ */
			100,			//CW_USEDEFAULT,		/* 		- WindowsɌ߂ */
			owner_hwnd,		/* eEBhE */
			NULL,			/* j[gpȂ */
			hInst,			/* vỖCX^X̃nh */
			NULL			/* ̂ق͕̈KvȂ */
			);
	ShowWindow(hwnd, SW_SHOW);
	UpdateWindow(hwnd);
	return(hwnd);
}

void resize(HWND This_hwnd, int w, int h, BOOL move)//w,h̓NCAg̈
{
	int		w1, h1, w2, h2, w3, h3;
	RECT	wr, cr;
	POINT	pt;
	MYBIT	temp;

	w1			= guide_img.GetW();				//̑傫
	h1			= guide_img.GetH();				//̑傫
	if (w1>h1) {
		w2			= w;
		h2			= h1 * w2 / w1;				//k̑傫iɂj
	}
	else {
		h2			= h;
		w2			= w1 * h2 / h1;				//k̑傫icɂj
	}
	if (w<w2 || h<h2) {
		if (h1>w1) {
			w2			= w;
			h2			= h1 * w2 / w1;				//k̑傫iɂj
		}
		else {
			h2			= h;
			w2			= w1 * h2 / h1;				//k̑傫icɂj
		}
	}
	temp.Stretch(&guide_img, w2, h2);
	guide_disp.Clear(RGB(128,128,128), w, h);
	guide_disp.Paste(&temp, (w-w2)/2, (h-h2)/2);
	if (move) {
		wr.left		= 0;
		wr.top		= 0;
		wr.right	= w;
		wr.bottom	= h;
		AdjustWindowRect(&wr, WS_OVERLAPPEDWINDOW, FALSE);
		w3			= wr.right  - wr.left;		//k̑傫iEChEŚj
		h3			= wr.bottom - wr.top;		//k̑傫iEChEŚj
		GetClientRect(owner_hwnd, &cr);
		pt.x		= cr.right;
		pt.y		= cr.bottom;
		ClientToScreen(owner_hwnd, &pt);
		MoveWindow(This_hwnd, pt.x-w3, pt.y-h3, w3, h3, TRUE);
	}
	InvalidateRect(This_hwnd, NULL, FALSE);
}

LRESULT CALLBACK Guide_win_Func(HWND This_hwnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	HINSTANCE		hInst;
	PAINTSTRUCT		p_str;
	HDC				wdc;

	switch(message) {
	case WM_CREATE:				/* ʍ쐬 */
		resize(This_hwnd, 120, 120, TRUE);
		break;
	case WM_SIZE:				/* TCYύX */
		if (wParam==SIZE_MAXIMIZED || wParam==SIZE_RESTORED) {
			resize(This_hwnd, LOWORD(lParam), HIWORD(lParam), FALSE);
		}
		break;
	case WM_PAINT:				/* ŕ`v */
		/*zfoCXɃobNAbvĂC[Wĕ`悷*/
		wdc = BeginPaint(This_hwnd, &p_str);			/*HDCƍĕ`͈͂擾*/
		guide_disp.Display(0, 0, wdc);
		EndPaint(This_hwnd, &p_str);				/*HDCJ*/
		break;
	case WM_CLOSE:
		DestroyWindow(This_hwnd);
		guide_hwnd	= NULL;
		break;
	default:
		return DefWindowProc(This_hwnd, message, wParam, lParam);/* Windows 98ŏ */
	}
	return 0;
}
