#include <windows.h>
#include <windowsx.h>
#include <process.h>
#include <stdlib.h>
#include "ini.h"
#include "view.h"
#include "piece.h"
#include "koukaon.h"

extern	void		nop();//gpȂ̃[jO߂̖ʂȃR[fBO

extern	VIEW		View[5];
extern	KOUKAON		koukaon;

LRESULT CALLBACK ViewWinFunc(HWND This_hwnd, UINT message, WPARAM wParam, LPARAM lParam);
int GetYukouNum(char *fname, int *cur_num);	//fL  piece.cppŒ`

VIEW::VIEW()
{
	int		i;

	for (i=0; i<10000; i++) {
		fname[i][0]		= '\0';
	}
	view_hwnd			= NULL;
	max					= 0;
	cur					= 0;
	dx					= 0;
	ddx					= 0;
	brake				= 0;
	accele				= 0;
	status				= 0;
	show				= FALSE;
	sel_no				= -1;
	sel_time			= 0;
	view_w_size			= VIEW_SIZE * 5;
}

VIEW::~VIEW()
{
}

void VIEW::register_class()
{
	WNDCLASSEX	wcl;

	/* EBhENX` */
	wcl.cbSize			= sizeof(WNDCLASSEX);
	wcl.hInstance		= hInst;										/* ̃CX^Xւ̃nh */
	wcl.lpszClassName	= "ViewWin";									/* EBhENX̖O */
	wcl.lpfnWndProc		= ViewWinFunc;									/* EBhE֐ */
	wcl.style			= 0;											/* ftHg̃X^C */
	wcl.hIcon			= LoadIcon(hInst, "EZJIG_ICON");				/* ACR */
	wcl.hIconSm			= NULL; 										/* ACR */
	wcl.hCursor			= LoadCursor(NULL, IDC_ARROW);					/* J[\̃X^C */
	wcl.lpszMenuName	= NULL;											/* Cj[ */
	wcl.cbClsExtra		= 0;											/* ̂ق͕̏KvȂ */
	wcl.cbWndExtra		= 0;											/* ̂ق͕̏KvȂ */
	wcl.hbrBackground	= NULL;//(HBRUSH) GetStockObject(WHITE_BRUSH);	/* wi͔ */
	/* EBhENXo^ */
	if(!RegisterClassEx(&wcl)) return;
}

void VIEW::create_window(int x, int y)
{
	RECT	r;
	int		w, h;
	DWORD	win_style;

	win_style = WS_CHILD | WS_CLIPSIBLINGS | (WS_OVERLAPPEDWINDOW & ~WS_THICKFRAME & ~WS_MAXIMIZEBOX);

	r.left		= 0;
	r.top		= 0;
	r.right		= view_w_size;
	r.bottom	= VIEW_SIZE;
	AdjustWindowRect(&r, win_style, FALSE);
	w			= r.right  - r.left;
	h			= r.bottom - r.top;
	view_h_fix	= h;
	view_hwnd = CreateWindow(
			"ViewWin",			/* EBhENX */
			"ezjig",			/* ^Cg */
			win_style,			/* EBhEX^C */
			x,					//CW_USEDEFAULT,/* XW 	- WindowsɌ߂ */
			y,					//CW_USEDEFAULT,/* YW	- WindowsɌ߂ */
			w,					//CW_USEDEFAULT,/*  		- WindowsɌ߂ */
			h,					//CW_USEDEFAULT,/* 		- WindowsɌ߂ */
			owner_hwnd,			/* eEBhE */
			NULL,				/* j[gpȂ */
			hInst,				/* vỖCX^X̃nh */
			NULL				/* ̂ق͕̈KvȂ */
			);
	if (view_hwnd==NULL) {
		MessageBox(NULL,"View CreateWindows","",MB_OK);
		return;
	}

	ShowWindow(view_hwnd, SW_SHOW);
	UpdateWindow(view_hwnd);

	show	= TRUE;
}

LRESULT CALLBACK ViewWinFunc(HWND This_hwnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	PAINTSTRUCT		p_str;
	POINT			mouse, p;
	int				view_no, w, h;
	RECT			r;

	for (view_no=0; view_no<5; view_no++) {
		if (View[view_no].GethWnd()==This_hwnd)
			break;
	}

	switch(message) {
	case WM_CREATE:
		SetTimer(This_hwnd, VIEW_LOOP, 50, NULL);
		break;
	case WM_TIMER:
		switch(wParam) {
		case VIEW_LOOP:
			View[view_no].Display(This_hwnd);
			InvalidateRect(This_hwnd, NULL, FALSE);
			SendMessage(This_hwnd, WM_PAINT, 0, 0);
			break;
		}
		break;
	case WM_LBUTTONDOWN:
		mouse.x	= GET_X_LPARAM(lParam);
		mouse.y	= GET_Y_LPARAM(lParam);
		View[view_no].Mouse_L_Down(mouse);
		break;
	case WM_LBUTTONUP:
		mouse.x	= GET_X_LPARAM(lParam);
		mouse.y	= GET_Y_LPARAM(lParam);
		View[view_no].Mouse_L_Up(mouse, view_no);
		break;
	case WM_MOUSEMOVE:
		mouse.x	= GET_X_LPARAM(lParam);
		mouse.y	= GET_Y_LPARAM(lParam);
		View[view_no].Mouse_Move(mouse, wParam);
		break;
	case WM_MOUSEWHEEL:
		mouse.x	= GET_X_LPARAM(lParam);
		mouse.y	= GET_Y_LPARAM(lParam);
		View[view_no].Mouse_Wheel(mouse, wParam);
		break;
	case WM_PAINT:
		BeginPaint(This_hwnd, &p_str);
		View[view_no].Display(This_hwnd);
		EndPaint(This_hwnd, &p_str);
		break;
	case WM_SIZE:
		if (view_no<5) {
			if (wParam==SIZE_MAXIMIZED || wParam==SIZE_RESTORED) {
				GetClientRect(This_hwnd, &r);
				View[view_no].SetW(r.right - r.left);
				GetWindowRect(This_hwnd, &r);
				w	= r.right - r.left;
				h	= View[view_no].GetHfix();
				p.x	= r.left;
				p.y	= r.top;
				ScreenToClient(View[view_no].GetOwner(), &p);
				MoveWindow(This_hwnd, p.x, p.y, w, h, TRUE);
			}
		}
		break;
	case WM_CLOSE:
		KillTimer(This_hwnd, VIEW_LOOP);
		DestroyWindow(This_hwnd);
		if (View[view_no].GetSelNo()==-1)	//IĂȂ
			PostMessage(View[view_no].GetOwner(), VIEW_SELMSG, view_no, 99999);
		View[view_no].Finish();
		break;
	default:
		return DefWindowProc(This_hwnd, message, wParam, lParam);/* Windows 98ŏ */
	}
	return 0;
}

void VIEW::Init(HWND owner, char *in_dir, int x, int y, int Dx)
{
	static BOOL		first=TRUE;
	int				i, j;
	MYBIT			temp;
	char			name[MAX_PATH];
	char			drive[100];
	RECT			r;

	owner_hwnd	= owner;
	dir			= in_dir;
	hInst		= (HINSTANCE)GetWindowLong(owner_hwnd, GWL_HINSTANCE);

	if (first==TRUE) {//ŏ
		first	= FALSE;
		register_class();//t@CIʂRegisterClassEx`
	}
	if (view_hwnd!=NULL) {
		SendMessage(view_hwnd, WM_CLOSE, 0, 0);//t@CIʕ\͂̉ʂ
	}
	create_window(x, y);//t@CIʂ쐬ĕ\

	lstrcpy(name, ini.program_dir);
	lstrcat(name,"\\frame.bmp");
	frame.ReadDIB(name,  hInst);		//g̉摜

	lstrcpy(name, ini.program_dir);
	lstrcat(name,"\\folder.bmp");
	folder.ReadDIB(name,  hInst);		//tH_̉摜

	lstrcpy(name, ini.program_dir);
	lstrcat(name,"\\arrow.bmp");
	arrow.ReadDIB(name,  hInst);		//̉摜

	for (int i=0; i<10; i++) {
		wsprintf(name,"%s\\%d.bmp", ini.program_dir, i);
		number[i].ReadDIB(name,  hInst);	//0,1,2,3..,9 ̐̉摜
		int w	= number[i].GetW();
		if (w<16) {							//16hbgȉ̏ꍇ͒ɔzu
			MYBIT	m;
			m.Clear(RGB(0,0,0), 16, 25);
			m.Paste(&number[i], (16-w)/2, 0);
			number[i].Copy(&m);
		}
	}

	for (i=0; i<10000; i++) {
		img[i].Reset();
		fname[i][0]		= '\0';//t@CGÃNA
	}
	max				= 0;
	cur				= 0;
	dx				= 0;
	ddx				= Dx;
	brake			= 0;
	accele			= 0;
	status			= 1;
	sel_no			= -1;
	sel_time		= 0;
	if (lstrcmp(dir, "/root")==0) {//hCũ[g
		GetLogicalDriveStrings(50, drive);//hCu擾iC:<null>D:<null>E:<null>...擾j
		i	= 0;
		j	= 0;
		while (drive[i]!='\0') {
			fname[j][0]	= 'B';//t@ĈPڂ͎ނ\i'B'̓tH_j
			lstrcpy(fname[j]+1, drive+i);//t@C2ڈȍ~ɃhCu
			i	= i + lstrlen(drive+i) + 1;
			j++;
		}
		max		= j;
		for (j=0; j<max; j++) {
			img[j].Clear(RGB(128,128,128), VIEW_SIZE, VIEW_SIZE);
			img[j].PasteA(&folder, (VIEW_SIZE-folder.GetW())/2, (VIEW_SIZE-folder.GetH())/2);
			r.left		= 6;
			r.right		= VIEW_SIZE - 6;
			r.top		= VIEW_SIZE - 25;
			r.bottom	= VIEW_SIZE - 6;
			img[j].Text(fname[j]+1, r, RGB(255,255,255), RGB(128,128,128));
			img[j].PasteA(&frame, 0, 0);//g
		}
		SetWindowText(view_hwnd, dir);
		status	= 2;
		Display(view_hwnd);
		InvalidateRect(view_hwnd, NULL, FALSE);
		SendMessage(view_hwnd, WM_PAINT, 0, 0);
		return;
	}
	else
		SetCurrentDirectory(dir);
	hTread		= _beginthreadex(NULL, 0, get_image_thread, (void*)(this), 0, &Tid);
}

void VIEW::Finish()	//WM_CLOSE󂯂̏
{
	status		= 3;
	show		= FALSE;
	view_hwnd	= NULL;
}

unsigned __stdcall get_image_thread(void *p)			/*Xbh*/
{
	VIEW	*pView;

	pView	= (VIEW*)p;
	pView->get_image_thread_loop();
	_endthreadex(0);
	return(0);
}

int sort_function(const void *a, const void *b)
{
	return(lstrcmp((char*)a,(char*)b));
}

void write_attr(char *path_name)	//ꗗŌt@C̑𒲂ׂtest.txtɏ
{
	return;//ׂ΂̍s폜

	HANDLE	hFile;
	DWORD	accbyte, attr;
	char	str[1000];
	char	test_fname[MAX_PATH];

	if (path_name==NULL) {
		lstrcpy(str, "\r\n");
	}
	else {
		lstrcpy(str, path_name);
		attr = GetFileAttributes(path_name);
		if (attr&FILE_ATTRIBUTE_READONLY)		lstrcat(str, " |READONLY");
		if (attr&FILE_ATTRIBUTE_HIDDEN)			lstrcat(str, " |HIDDEN");
		if (attr&FILE_ATTRIBUTE_SYSTEM)			lstrcat(str, " |SYSTEM");
		if (attr&FILE_ATTRIBUTE_DIRECTORY)		lstrcat(str, " |DIRECTORY");
		if (attr&FILE_ATTRIBUTE_ARCHIVE)		lstrcat(str, " |ARCHIVE");
		if (attr&FILE_ATTRIBUTE_ENCRYPTED)		lstrcat(str, " |ENCRYPTED");
		if (attr&FILE_ATTRIBUTE_NORMAL)			lstrcat(str, " |NORMAL");
		if (attr&FILE_ATTRIBUTE_TEMPORARY)		lstrcat(str, " |TEMPORARY");
		if (attr&FILE_ATTRIBUTE_SPARSE_FILE)	lstrcat(str, " |SPARSE_FILE");
		if (attr&FILE_ATTRIBUTE_REPARSE_POINT)	lstrcat(str, " |REPARSE_POINT");
		if (attr&FILE_ATTRIBUTE_COMPRESSED)		lstrcat(str, " |COMPRESSED");
		if (attr&FILE_ATTRIBUTE_OFFLINE)		lstrcat(str, " |OFFLINE");
		lstrcat(str, "\r\n");
	}
	lstrcpy(test_fname, ini.program_dir);
	lstrcat(test_fname,"\\test.txt");
	hFile = CreateFile(test_fname, GENERIC_WRITE, 0, 0, OPEN_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL);
	SetFilePointer(hFile, 0, NULL, FILE_END);
	WriteFile(hFile, str, lstrlen(str), &accbyte, NULL);
	CloseHandle(hFile);
}

void VIEW::get_image_thread_loop()
{
	WIN32_FIND_DATA	FindFileData;
	HANDLE			handle;
	char			search_fname[MAX_PATH];
	char			path_name   [MAX_PATH];
	char			s_drive     [_MAX_DRIVE];
	char			s_dir       [_MAX_DIR];
	char			s_name      [_MAX_FNAME];
	char			s_ext       [_MAX_EXT];
	int				i, j, k, w, h;
	MYBIT			temp;
	char			ftype;
	RECT			r;
	BOOL			rc;

	i	= 0;
	if (lstrlen(dir)==2 && dir[1]==':') {//hCũ[g
		lstrcat(fname[i++], "A..");
	}
	lstrcpy(search_fname, dir);
	write_attr(dir);
	lstrcat(search_fname, "\\*.*");
	handle = FindFirstFile(search_fname, &FindFileData);
	if (handle==INVALID_HANDLE_VALUE)/*0*/
		return;
	rc	= TRUE;
	while (rc) {//t@Cꗗ̎擾
		lstrcpy(path_name, dir);
		lstrcat(path_name, "\\");
		lstrcat(path_name, FindFileData.cFileName);
		_splitpath(path_name, s_drive, s_dir, s_name, s_ext);
		write_attr(path_name);
		DWORD attr = GetFileAttributes(path_name);

		ftype	= 0;
		if (lstrcmp(s_dir+lstrlen(s_dir)-3, "\\..")==0)		//ʃtH_
			ftype	= 'A';
		else
		if (lstrcmp(s_dir+lstrlen(s_dir)-3, "\\.")==0)		//JgtH_[
			ftype	= 'X';
		else
		if (attr & FILE_ATTRIBUTE_HIDDEN)					//Bt@CȂ
			ftype	= 'X';
		else
		if (attr & FILE_ATTRIBUTE_DIRECTORY)				//tH_[
			ftype	= 'B';
		else
		if (attr & FILE_ATTRIBUTE_ARCHIVE)					//t@C
			ftype	= 'F';

		if (lstrcmp(s_dir+lstrlen(s_dir)-2, "\\.")!=0) {
			if (//(ftype=='A'                               ) ||	//ʃtH_[
//				(ftype=='B'                               ) ||	//tH_[
				(ftype=='F' && lstrcmpi(s_ext, ".jpg" )==0) ||	//摜t@C
				(ftype=='F' && lstrcmpi(s_ext, ".jpeg")==0) ||	//摜t@C
				(ftype=='F' && lstrcmpi(s_ext, ".bmp" )==0) ||	//摜t@C
				(ftype=='F' && lstrcmpi(s_ext, ".ezj" )==0)) {	//Q[ff[^t@C
				//LȊÕ^Cṽt@CfBNg͖
				if (i<10000) {
					fname[i][0]	= ftype;//t@ĈPڂɎނ\
					lstrcpy(fname[i]+1, path_name);
					i++;
				}
				else {
					MessageBox(NULL,"10000ȏ̃t@C͖܂","ezjig",MB_OK);
					break;
				}
			}
		}
		rc	= FindNextFile(handle, &FindFileData);
	}
	FindClose(handle);
//	write_attr(NULL);

	qsort((void*)fname, i, sizeof(fname[0]), sort_function);// i ̃t@C\[g

	SetCursor(LoadCursor(NULL, IDC_WAIT));
	for (j=0; j<i; j++) {
		img[j].Clear(RGB(128,128,128), VIEW_SIZE, VIEW_SIZE);
		if (fname[j][0]=='F') {//摜t@C
			temp.ReadDIBS(fname[j]+1, hInst, VIEW_SIZE);
			img[j].Paste(&temp, (VIEW_SIZE-temp.GetW())/2, (VIEW_SIZE-temp.GetH())/2);
			if (lstrcmpi(fname[j]+lstrlen(fname[j])-4, ".ezj")==0) {//Q[ff[^t@C
				int		cur_num, total, i, x;
				char	str[10];
				total	= GetYukouNum(fname[j]+1, &cur_num);
				wsprintf(str, "%d", cur_num);
				for (i=0; str[i]!='\0'; i++) {
					img[j].PasteA(&number[str[i]-0x30], i*16+5, 5);
				}
				wsprintf(str, "%d", total);
				x	= VIEW_SIZE - 16 - 5;
				for (i=lstrlen(str)-1; i>=0; i--) {
					img[j].PasteA(&number[str[i]-0x30], x, VIEW_SIZE - 25 - 5);
					x	-= 16;
				}
			}
		}

		else {
			if (fname[j][0]=='A') {//ʃfBNg
				img[j].PasteA(&folder, (VIEW_SIZE-folder.GetW())/2, (VIEW_SIZE-folder.GetH())/2);
				img[j].PasteA(&arrow,  (VIEW_SIZE-arrow .GetW())/2, (VIEW_SIZE-arrow .GetH())/2);
			}
			else {//tH_[
				img[j].PasteA(&folder, (VIEW_SIZE-folder.GetW())/2, (VIEW_SIZE-folder.GetH())/2);
				r.left		= 6;
				r.right		= VIEW_SIZE - 6;
				r.top		= VIEW_SIZE - 25;
				r.bottom	= VIEW_SIZE - 6;
				for (k=lstrlen(fname[j])-1; fname[j][k]!='\\'; k--)
					;
				img[j].Text(fname[j]+k+1, r, RGB(255,255,255), RGB(128,128,128));
			}
		}
		img[j].PasteA(&frame, 0, 0);//g
		max		= j + 1;
	}
	SetCursor(LoadCursor(NULL, IDC_ARROW));
	SetWindowText(view_hwnd, dir);
	status	= 2;
	koukaon.start();
}

void VIEW::Mouse_L_Down(POINT mouse_now)
{
	mouse		= mouse_now;
	brake		= ddx;
	ddx			= 0;
	sel_time	= GetTickCount();
	sel_no		= GetPointNo(mouse);
}

void VIEW::Mouse_L_Up(POINT mouse_now, int view_no)
{
	if (ClickCheck(mouse_now)==TRUE) {
		if (fname[sel_no][0]=='A')
			Change_Dir((char*)"..");
		else
		if (fname[sel_no][0]=='B')
			Change_Dir(fname[sel_no]+1);
		else {
			PostMessage(owner_hwnd, VIEW_SELMSG, view_no, sel_no);
			Hide();
		}
	}
}

void VIEW::Mouse_Move(POINT mouse_now, WPARAM wParam)
{
	float	fx;

	if (wParam&MK_LBUTTON) {
		fx		= mouse.x - mouse_now.x;
//		accele	= (accele * 0.9) + (fx * 0.1);
		ddx		= (ddx    * 0.9) + (fx * 0.1);
		mouse	= mouse_now;
	}
}

void VIEW::Mouse_Wheel(POINT mouse_now, WPARAM wParam)
{
	if (mouse_now.x==0) nop();//gpȂ̃[jO߂̖ʂȃR[fBO

	WORD	wd;
	short	*sh;

	wd	= HIWORD(wParam);
	sh	= (short*)&wd;
	if (*sh<0) {
		cur++;
		if (cur>=max)
			cur	= 0;
	}
	else {
		cur--;
		if (cur<0)
			cur	= max - 1;
	}
	dx		= 0;
	ddx		= 0;
	brake	= 0;
	accele	= 0;
}

void VIEW::Display(HWND hwnd)
{
	int		i, j, k;
	RECT	r;

	dx			= dx + ddx + brake - accele;
	brake		= brake  * 0.95;
	accele		= accele * 0.95;
	if (dx>0) {
		if (dx>=VIEW_SIZE) {
			dx	= dx - VIEW_SIZE;
			cur++;
			if (cur>=max)
				cur	= 0;
		}
	}
	else if (dx<0) {
		dx	= dx + VIEW_SIZE;
		cur--;
		if (cur<0)
			cur	= max - 1;
	}

	if (show==FALSE || status==0)
		return;

	GetClientRect(hwnd, &r);
	k	= (r.right / VIEW_SIZE) + 2;
	desk.Clear(RGB(128,128,128), VIEW_SIZE*k, VIEW_SIZE);
	if (k-2<max) {
		j	= cur;
		for (i=0; i<k; i++) {
			desk.Paste(&img[j], i*VIEW_SIZE-dx, 0);
			j++;
			if (j>=max)
				j	= 0;
		}
		desk.Display(0, 0, hwnd);
	}
	else {
		if (status==2) {
			cur	= 0;
			dx	= 0;
			ddx	= 0;
			j	= 0;
			for (i=0; i<k; i++) {
				desk.Paste(&img[j], i*VIEW_SIZE, 0);
				j++;
				if (j>=max)
					break;
			}
			desk.Display(0, 0, hwnd);
		}
	}
}

int VIEW::GetPointNo(POINT mouse)
{
	int		i;

	i	= cur + (mouse.x+dx) / VIEW_SIZE;
	i	= i % max;
	return(i);
}

BOOL VIEW::ClickCheck(POINT mouse)
{
	DWORD	time;
	int		no;

	time	= GetTickCount();
	no		= GetPointNo(mouse);
	if (time-sel_time<1000 && no==sel_no) {
		return(TRUE);
	}
	sel_time	= time;
	sel_no		= no;
	return(FALSE);
}

void VIEW::Change_Dir(char *dname)
{
	RECT	r;
	POINT	p;

	if (lstrcmp(dname, "..")==0 && lstrlen(dir)==2 && dir[1]==':') {//hCũ[g
		lstrcpy(dir, "/root");
	}
	else {
		if (SetCurrentDirectory(dname)==TRUE) {
			GetCurrentDirectory(MAX_PATH, dir);
			if (lstrlen(dir)==3 && dir[1]==':' && dir[2]=='\\') {//hCũ[g
				dir[2]	= '\0';//C:\\Jbg
			}
		}
		else
			MessageBeep(MB_ICONHAND);
	}
	GetWindowRect(view_hwnd, &r);
	p.x		= r.left;
	p.y		= r.top;
	ScreenToClient(owner_hwnd, &p);
	Init(owner_hwnd, dir, p.x, p.y, 0);
}

