// view.h

#ifndef		_VIEW_H_
#define		_VIEW_H_

#include "mybit.h"

#define		VIEW_SIZE		100
#define		VIEW_SELMSG		0x5100
#define		VIEW_LOOP		0x5101

unsigned __stdcall get_image_thread(void *p);			/*Xbh*/

class VIEW {
	unsigned		Tid;		//گid
	unsigned long	hTread;		//گhandle
	HINSTANCE	hInst;
	HWND	owner_hwnd;
	HWND	view_hwnd;
	MYBIT	img[10000];
	MYBIT	desk;
	int		max;
	int		cur;
	POINT	mouse;
	float	dx;
	float	ddx;
	float	brake;
	float	accele;
	char	*dir;
	char	fname[10000][MAX_PATH];
	int		status;		//0:lA1:ǂݍݒA2:ǂݍݏIA3:ʃN[Y
	BOOL	show;		//TRUE:\A1:\
	int		sel_no;
	int		sel_time;
	MYBIT	frame;
	MYBIT	folder;		//tH_[̉摜C[W
	MYBIT	arrow;		//ʃtH_[ֈړ̉摜C[W
	MYBIT	number[10];	//0,1,2,...f摜ɕ\s[X̐̉摜C[W
	int		view_h_fix;
	int		view_w_size;
private:
	void	register_class			();
	void	create_window			(int x=0, int y=0);
	void	Change_Dir				(char *dname);
	int		GetPointNo				(POINT mouse);
	BOOL	ClickCheck				(POINT mouse);
	void	Hide					() {
											ShowWindow(view_hwnd, SW_HIDE);
											show	= FALSE;
										}
public:
	VIEW();
	~VIEW();
	void	Init					(HWND owner_hwnd, char *dir, int x=0, int y=0, int Dx=0);
	void	Finish					();
	void	get_image_thread_loop	();
	void	Mouse_L_Down			(POINT mouse);
	void	Mouse_L_Up				(POINT mouse, int view_no);
	void	Mouse_Move				(POINT mouse, WPARAM wParam);
	void	Mouse_Wheel				(POINT mouse, WPARAM wParam);
	void	Display					(HWND hwnd);
	void	Show					() {
											ShowWindow(view_hwnd, SW_SHOW);
											show	= TRUE;
										}
	int		GetSelNo				()			{return(sel_no);}
	char*	GetFname				(int no)	{return(fname[no]+1);}
	int		GetStatus				()			{return(status);}
	HWND	GetOwner				()			{return(owner_hwnd);}
	HWND	GethWnd					()			{return(view_hwnd);}
	int		GetHfix					()			{return(view_h_fix);}
	void	SetW					(int w)		{view_w_size=w;}
};

#endif		/*_VIEW_H_*/
