
#include "koukaon.h"
#include "ini.h"

KOUKAON::KOUKAON()
{
}

KOUKAON::~KOUKAON()
{
}

void KOUKAON::init(char *sound_dir)
{
	lstrcpy(fn_start,   sound_dir);		lstrcat(fn_start,   "\\k_start");
	lstrcpy(fn_wait,    sound_dir);		lstrcat(fn_wait,    "\\k_wait");
	lstrcpy(fn_joint,   sound_dir);		lstrcat(fn_joint,   "\\k_joint");
	lstrcpy(fn_end_1,   sound_dir);		lstrcat(fn_end_1,   "\\k_end_1");
	lstrcpy(fn_end_2,   sound_dir);		lstrcat(fn_end_2,   "\\k_end_2");
	lstrcpy(fn_end_3,   sound_dir);		lstrcat(fn_end_3,   "\\k_end_3");
	lstrcpy(fn_end_4,   sound_dir);		lstrcat(fn_end_4,   "\\k_end_4");
	lstrcpy(fn_close_1, sound_dir);		lstrcat(fn_close_1, "\\k_close_1");
	lstrcpy(fn_close_2, sound_dir);		lstrcat(fn_close_2, "\\k_close_2");
}

void KOUKAON::start()
{
	if (ini.sound==FALSE) return;
	PlaySound(fn_start, NULL, SND_FILENAME | SND_NOWAIT);
}

void KOUKAON::wait()
{
	if (ini.sound==FALSE) return;
	PlaySound(fn_wait, NULL, SND_FILENAME | SND_NOWAIT);
}

void KOUKAON::joint()
{
	if (ini.sound==FALSE) return;
	PlaySound(fn_joint, NULL, SND_FILENAME | SND_NOWAIT);
}

void KOUKAON::end()
{
	int		i;

	if (ini.sound==FALSE) return;
	i = rand() % 4;
	if (i==0)	PlaySound(fn_end_1, NULL, SND_FILENAME | SND_NOWAIT);
	if (i==1)	PlaySound(fn_end_2, NULL, SND_FILENAME | SND_NOWAIT);
	if (i==2)	PlaySound(fn_end_3, NULL, SND_FILENAME | SND_NOWAIT);
	if (i==3)	PlaySound(fn_end_4, NULL, SND_FILENAME | SND_NOWAIT);
}

void KOUKAON::close()
{
	int		i;

	if (ini.sound==FALSE) return;
	i = rand() % 2;
	if (i==0)	PlaySound(fn_close_1, NULL, SND_FILENAME | SND_NOWAIT);
	if (i==1)	PlaySound(fn_close_2, NULL, SND_FILENAME | SND_NOWAIT);
}
