//bzline.cpp

#include <windows.h>
#include "bzline.h"

BZ::BZ()
{
	num		= 0;
	bz		= NULL;
}

BZ::~BZ()
{
	Free();
}

void BZ::Alloc(int n)
{
	Free();
	bz	= (POINT*)GlobalAlloc(GMEM_FIXED, sizeof(POINT)*n);
	num	= n;
}

void BZ::Free()
{
	if (bz!=NULL) {
		GlobalFree(bz);
		bz	= NULL;
	}
	num		= 0;
}

