// desk.h
#ifndef DESK_H
#define DESK_H

#include <windows.h>
#include "mybit.h"

class DESK {
	HWND			hWnd;
	MYBIT			desk;
	MYBIT			back;
	MYBIT			back_sv;
	MYBIT			back_img;
private:
public:
	DESK				();
	~DESK				();
	void	Init		(HWND hwnd);
	void	Clear		();
	BOOL	ChangeRGB	();
	void	ChangeTile	(char * name);
	void	SetBackImg	(MYBIT *img);
	void	PasteBackImg();
	void	ResetBackImg();
	MYBIT*	GetDeskPtr	() {return(&desk);}
	MYBIT*	GetBackPtr	() {return(&back);}
};

#endif /*DESK_H*/

