//patternline.cpp

#include <windows.h>
#include <windowsx.h>
#include <commctrl.h>
#include <math.h>
#include "ezjig.h"
#include "mybit.h"

LRESULT CALLBACK PatternLine_Win_Func(HWND, UINT, WPARAM, LPARAM);
LRESULT CALLBACK PatternLine2_Win_Func(HWND, UINT, WPARAM, LPARAM);

HWND	PatternLine_hWnd;
HWND	PatternLine2_hWnd;
HWND	hToolBar;

void PatternLine_register_class(HINSTANCE hInstance)
{
	WNDCLASSEX wcl;

	/* EBhENX` */
	wcl.cbSize			= sizeof(WNDCLASSEX);
	wcl.hInstance		= hInstance;								/* ̃CX^Xւ̃nh */
	wcl.lpszClassName	= "PatternlineLineWin";						/* EBhENX̖O */
	wcl.lpfnWndProc		= PatternLine_Win_Func;						/* EBhE֐ */
	wcl.style			= 0;										/* ftHg̃X^C */
	wcl.hIcon			= LoadIcon(hInstance, "EZJIG_ICON");//NULL;	/* ACR */
	wcl.hIconSm			= NULL; //LoadIcon(NULL, IDI_WINLOGO);		/* ACR */
	wcl.hCursor			= LoadCursor(NULL, IDC_ARROW);				/* J[\̃X^C */
	wcl.lpszMenuName	= NULL;										/* j[gpȂ */
	wcl.cbClsExtra		= 0;										/* ̂ق͕̏KvȂ */
	wcl.cbWndExtra		= 0;										/* ̂ق͕̏KvȂ */
	wcl.hbrBackground	= NULL;//(HBRUSH) GetStockObject(WHITE_BRUSH);		/* wi͔ */

	/* EBhENXo^ */
	if(!RegisterClassEx(&wcl)) return;
}

HWND PatternLine_create_window(HINSTANCE hInstance, HWND owner_hwnd)
{
	POINT	p;
	static BOOL		first=TRUE;

	if (first==TRUE) {
		first	= FALSE;
		PatternLine_register_class(hInstance);
	}

	p.x			= 0;
	p.y			= 0;
	ClientToScreen(owner_hwnd, &p);
	PatternLine_hWnd = CreateWindow(
		"PatternlineLineWin",				/* EBhENX */
		"p^[쐬",						/* ^Cg */
		WS_POPUP | WS_CAPTION | WS_SYSMENU,
		p.x,//CW_USEDEFAULT,				/* XW 	- WindowsɌ߂ */
		p.y,//CW_USEDEFAULT,				/* YW	- WindowsɌ߂ */
		200,//CW_USEDEFAULT,				/*  		- WindowsɌ߂ */
		200,//CW_USEDEFAULT,				/* 		- WindowsɌ߂ */
		owner_hwnd,							/* eEBhE */
		NULL,								/* j[gpȂ */
		hInstance,							/* vỖCX^X̃nh */
		NULL								/* ̂ق͕̈KvȂ */
	);

	/* EBhE\ */
	ShowWindow(PatternLine_hWnd, SW_SHOW);
	UpdateWindow(PatternLine_hWnd);
	return(PatternLine_hWnd);
}

//̃EChE
void PatternLine2_register_class(HINSTANCE hInstance)
{
	WNDCLASSEX wcl;

	/* EBhENX` */
	wcl.cbSize			= sizeof(WNDCLASSEX);
	wcl.hInstance		= hInstance;								/* ̃CX^Xւ̃nh */
	wcl.lpszClassName	= "PatternlineLine2Win";					/* EBhENX̖O */
	wcl.lpfnWndProc		= PatternLine2_Win_Func;					/* EBhE֐ */
	wcl.style			= 0;										/* ftHg̃X^C */
	wcl.hIcon			= LoadIcon(hInstance, "EZJIG_ICON");//NULL;	/* ACR */
	wcl.hIconSm			= NULL; //LoadIcon(NULL, IDI_WINLOGO);		/* ACR */
	wcl.hCursor			= LoadCursor(NULL, IDC_ARROW);				/* J[\̃X^C */
	wcl.lpszMenuName	= NULL;										/* j[gpȂ */
	wcl.cbClsExtra		= 0;										/* ̂ق͕̏KvȂ */
	wcl.cbWndExtra		= 0;										/* ̂ق͕̏KvȂ */
	wcl.hbrBackground	= NULL;//(HBRUSH) GetStockObject(WHITE_BRUSH);		/* wi͔ */

	/* EBhENXo^ */
	if(!RegisterClassEx(&wcl)) return;
}

//̃EChE
HWND PatternLine2_create_window(HINSTANCE hInstance, HWND owner_hwnd)
{
	PatternLine2_hWnd = CreateWindow(
		"PatternlineLine2Win",				/* EBhENX */
		"p^[쐬",						/* ^Cg */
		WS_CHILD,
		0,//CW_USEDEFAULT,				/* XW 	- WindowsɌ߂ */
		30,//CW_USEDEFAULT,				/* YW	- WindowsɌ߂ */
		200,//CW_USEDEFAULT,				/*  		- WindowsɌ߂ */
		200,//CW_USEDEFAULT,				/* 		- WindowsɌ߂ */
		owner_hwnd,							/* eEBhE */
		NULL,								/* j[gpȂ */
		hInstance,							/* vỖCX^X̃nh */
		NULL								/* ̂ق͕̈KvȂ */
	);

	/* EBhE\ */
	ShowWindow(PatternLine2_hWnd, SW_SHOW);
	UpdateWindow(PatternLine2_hWnd);
	return(PatternLine2_hWnd);
}

void toolbar(HWND hwnd)
{
	TBBUTTON	tbb[] = {
							{0, IDM_TB_CLEAR, TBSTATE_ENABLED, TBSTYLE_BUTTON, 0, 0},
							{1, IDM_TB_INPUT, TBSTATE_ENABLED, TBSTYLE_BUTTON, 0, 0},
							{2, IDM_TB_OUTPUT,TBSTATE_ENABLED, TBSTYLE_BUTTON, 0, 0},
							{3, IDM_TB_PEN,   TBSTATE_ENABLED, TBSTYLE_BUTTON, 0, 0},
							{4, IDM_TB_HAND,  TBSTATE_ENABLED, TBSTYLE_BUTTON, 0, 0}
						};
	TBBUTTON	tb = {0, 0, TBSTATE_ENABLED, TBSTYLE_SEP, 0, 0};//؂
	char		ch[5][20] = {"NA","","o","`","H"};

	HWND	hToolTip;
	TOOLINFO	ti;
	int			i;

	HINSTANCE hInstance = (HINSTANCE)GetWindowLong(hwnd, GWL_HINSTANCE);

	InitCommonControls();
	hToolBar = CreateToolbarEx(
					hwnd,		//eEBhE
					WS_CHILD | WS_VISIBLE | WS_CLIPSIBLINGS |TBSTYLE_TOOLTIPS,	//EBhEX^C
					ID_TOOLBAR,	// Rg[ID
					5,			//C[W̐
					hInstance,
					ID_MYBMP,	//C[W
					tbb,		//{^̌`
					5,			//{^̐
					0,			//{^̕
					0,			//{^̍
					24,			//C[W̕
					24,			//C[W̍
					sizeof(TBBUTTON));
	SendMessage(hToolBar, TB_INSERTBUTTON, 3, (LPARAM)&tb);//؂̑}
	SendMessage(hToolBar, TB_AUTOSIZE, 0, 0);

	// c[`bv
	hToolTip = CreateWindowEx(
					0,					//gEBhEX^C
					TOOLTIPS_CLASS,		//NXl[
					NULL,				//EBhEl[
					TTS_ALWAYSTIP,		// EBhEX^C
					CW_USEDEFAULT,		// wW
					CW_USEDEFAULT,		// xW
					CW_USEDEFAULT,		// 
					CW_USEDEFAULT,		// 
					hwnd,				// eEBhẼnh
					NULL,				// j[nh
					hInstance,			// CX^Xnh
					NULL);				// WM_CREATEf[^

	ti.cbSize	= sizeof(TOOLINFO);
	ti.hwnd		= hToolBar;
	ti.hinst	= hInstance;
	ti.uFlags	= TTF_SUBCLASS;
	for (i=0; i<5; i++) {
		SendMessage(hToolBar, TB_GETITEMRECT, IDM_TB_CLEAR+i, (LPARAM)&ti.rect);
		ti.uId = tbb[i].idCommand;
		ti.lpszText = ch[i];
		SendMessage(hToolTip, TTM_ADDTOOL, 0, (LPARAM)&ti);
	}
	SendMessage(hToolBar, TB_SETTOOLTIPS, (WPARAM)hToolTip, 0);
}

LRESULT CALLBACK PatternLine_Win_Func(HWND This_hwnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	static BOOL first=TRUE;

	PatternLine_hWnd	= This_hwnd;
	HINSTANCE hInstance = (HINSTANCE)GetWindowLong(This_hwnd, GWL_HINSTANCE);

	switch(message) {
	case WM_CREATE:
		toolbar(This_hwnd);
		if (first==TRUE) {
			first	= FALSE;
			PatternLine2_register_class(hInstance);
		}
		PatternLine2_create_window(hInstance, This_hwnd);
		break;
	case WM_COMMAND:
		switch (LOWORD(wParam)) {
		case IDM_TB_CLEAR:
			SendMessage(PatternLine2_hWnd, IDM_TB_CLEAR, 0, 0);
			break;
		case IDM_TB_INPUT:
			SendMessage(PatternLine2_hWnd, IDM_TB_INPUT, 0, 0);
			break;
		case IDM_TB_OUTPUT:
			SendMessage(PatternLine2_hWnd, IDM_TB_OUTPUT, 0, 0);
			break;
		case IDM_TB_PEN:
			SendMessage(hToolBar, TB_CHECKBUTTON, (WPARAM)IDM_TB_PEN,  TRUE);
			SendMessage(hToolBar, TB_CHECKBUTTON, (WPARAM)IDM_TB_HAND, FALSE);
			PostMessage(PatternLine2_hWnd, IDM_TB_PEN, 0, 0);
			break;
		case IDM_TB_HAND:
			SendMessage(hToolBar, TB_CHECKBUTTON, (WPARAM)IDM_TB_PEN,  FALSE);
			SendMessage(hToolBar, TB_CHECKBUTTON, (WPARAM)IDM_TB_HAND, TRUE);
			PostMessage(PatternLine2_hWnd, IDM_TB_HAND, 0, 0);
			break;
		}
		break;
	case WM_CLOSE:
		DestroyWindow(This_hwnd);
		break;
	default:
		return DefWindowProc(This_hwnd, message, wParam, lParam);/* Windows 98ŏ */
	}
	return 0;
}

void Spline2(POINT ln1[], POINT ln2[], int num1, int num2);

BOOL add_point(POINT mouse, POINT ln1[], int *num1)
{
	(*num1)++;
	ln1[*num1]	= mouse;
	return(TRUE);
}

void draw(HDC dc, int w, int h, POINT ln1[], int num1, POINT ln2[], int num2)
{
	int		i;

	PatBlt(dc, 0, 0, w, h, WHITENESS);
	Polyline(dc, ln2, num2);
	for (i=0; i<num1; i++) {
		SetPixelV(dc, ln1[i].x, ln1[i].y, RGB(255,0,0));
	}
}

LRESULT CALLBACK PatternLine2_Win_Func(HWND This_hwnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	PAINTSTRUCT			p_str;
	HDC					wdc;
	int					i;
	static HDC			dc;
	static HBITMAP		bit,	bit_old;
	static int			desk_x, desk_y;
	static HPEN			pen1, pen2, pen_old;
	static POINT		ln1[1000], ln2[10000], mouse;
	static int			num=0;

	switch(message) {
	case WM_CREATE:
		RECT	r1, r2;
		int		x, y, w, h;

		GetWindowRect(PatternLine_hWnd, &r1);
		GetWindowRect(hToolBar, &r2);
		w			= r1.right - r1.left;
		h			= (r1.bottom - r1.top) + (r2.bottom - r2.top);
		MoveWindow(PatternLine_hWnd, r1.top, r1.left, w, h, TRUE);

		GetClientRect(PatternLine_hWnd, &r1);
		GetWindowRect(hToolBar, &r2);
		x			= 0;
		y			= r2.bottom - r2.top;
		w			= r1.right - r1.left;
		h			= r1.bottom - r1.top + y;
		MoveWindow(This_hwnd, x, y, w, h, TRUE);

		wdc			= GetDC(This_hwnd);									/*foCXReLXgnh擾*/
		desk_x		= GetSystemMetrics(SM_CXSCREEN);					/*fXNgbv̕*/
		desk_y		= GetSystemMetrics(SM_CYSCREEN);					/*fXNgbv̍*/
		dc			= CreateCompatibleDC(wdc);							/*݊foCXReLXg擾*/
		bit			= CreateCompatibleBitmap(wdc, desk_x, desk_y);		/*݊rbg}bv擾(fXNgbvŜ̑傫)*/
		ReleaseDC(This_hwnd, wdc);										/*foCXReLXgJ*/
		pen1		= (HPEN)CreatePen(PS_SOLID, 1, RGB(0,0,0));			//
		pen2		= (HPEN)CreatePen(PS_SOLID, 1, RGB(255,0,0));		//
		bit_old		= (HBITMAP)SelectObject(dc,  bit);					/*rbg}bvI*/
		pen_old		= (HPEN)SelectObject(dc, pen1);
		PatBlt(dc, 0, 0, desk_x, desk_y, WHITENESS);
		break;
	case WM_LBUTTONDOWN:
		num			= 0;
		mouse.x		= GET_X_LPARAM(lParam);
		mouse.y		= GET_Y_LPARAM(lParam);
		ln1[num]	= mouse;
		break;
	case WM_MOUSEMOVE:
		if (wParam&MK_LBUTTON) {
			mouse.x		= GET_X_LPARAM(lParam);
			mouse.y		= GET_Y_LPARAM(lParam);
			if (num<999) {
				if (add_point(mouse, ln1, &num)==TRUE) {
					Spline2(ln1, ln2, num+1, (num+1)*10);
					draw(dc, desk_x, desk_y, ln1, num+1, ln2, (num+1)*10);
					InvalidateRect(This_hwnd, NULL, FALSE);
				}
			}
		}
		break;
	case WM_PAINT:
		/*zfoCXɃobNAbvĂC[Wĕ`悷*/
		wdc = BeginPaint(This_hwnd, &p_str);						/*HDCƍĕ`͈͂擾*/
		BitBlt(wdc,
			   p_str.rcPaint.left,							/*wdĉ̈ʒu(x)*/
			   p_str.rcPaint.top,							/*wdĉ̈ʒu(y)*/
			   p_str.rcPaint.right  - p_str.rcPaint.left,	/*wdĉ̕*/
			   p_str.rcPaint.bottom - p_str.rcPaint.top,	/*wdĉ̍*/
			   dc,
			   p_str.rcPaint.left,							/*memdc1̂(x)*/
			   p_str.rcPaint.top,							/*memdc1̂(y)*/
			   SRCCOPY);									/*PRs[*/
		EndPaint(This_hwnd, &p_str);								/*HDCJ*/
		break;
	case IDM_TB_CLEAR:
		PatBlt(dc, 0, 0, desk_x, desk_y, WHITENESS);
		InvalidateRect(This_hwnd, NULL, FALSE);
		break;
	case IDM_TB_INPUT:
		break;
	case IDM_TB_OUTPUT:
		break;
	case IDM_TB_PEN:
		break;
	case IDM_TB_HAND:
		break;
	case WM_CLOSE:
		SelectObject(dc,  pen_old);
		SelectObject(dc,  bit_old);
		DeleteObject(bit);
		DeleteDC(dc);
		DestroyWindow(This_hwnd);
	default:
		return DefWindowProc(This_hwnd, message, wParam, lParam);/* Windows 98ŏ */
	}
	return 0;
}

